Add the core of the instance status collector
[ganeti-local] / Makefile.am
1 # Ganeti makefile
2 # - Indent with tabs only.
3 # - Keep files sorted; one line per file.
4 # - Directories in lib/ must have their own *dir variable (see hypervisor).
5 # - All directories must be listed DIRS.
6 # - Use autogen.sh to generate Makefile.in and configure script.
7
8 # Automake doesn't export these variables before version 1.10.
9 abs_top_builddir = @abs_top_builddir@
10 abs_top_srcdir = @abs_top_srcdir@
11
12 # Helper values for calling builtin functions
13 empty :=
14 space := $(empty) $(empty)
15 comma := ,
16
17 # Helper function to strip src/ and test/hs/ from a list
18 strip_hsroot = $(patsubst src/%,%,$(patsubst test/hs/%,%,$(1)))
19
20 # Use bash in order to be able to use pipefail
21 SHELL=/bin/bash
22
23 ACLOCAL_AMFLAGS = -I autotools
24 BUILD_BASH_COMPLETION = $(top_srcdir)/autotools/build-bash-completion
25 RUN_IN_TEMPDIR = $(top_srcdir)/autotools/run-in-tempdir
26 CHECK_PYTHON_CODE = $(top_srcdir)/autotools/check-python-code
27 CHECK_HEADER = $(top_srcdir)/autotools/check-header
28 CHECK_MAN_DASHES = $(top_srcdir)/autotools/check-man-dashes
29 CHECK_MAN_REFERENCES = $(top_srcdir)/autotools/check-man-references
30 CHECK_MAN_WARNINGS = $(top_srcdir)/autotools/check-man-warnings
31 CHECK_VERSION = $(top_srcdir)/autotools/check-version
32 CHECK_NEWS = $(top_srcdir)/autotools/check-news
33 CHECK_IMPORTS = $(top_srcdir)/autotools/check-imports
34 DOCPP = $(top_srcdir)/autotools/docpp
35 REPLACE_VARS_SED = autotools/replace_vars.sed
36 CONVERT_CONSTANTS = $(top_srcdir)/autotools/convert-constants
37 BUILD_RPC = $(top_srcdir)/autotools/build-rpc
38 SHELL_ENV_INIT = autotools/shell-env-init
39
40 # Note: these are automake-specific variables, and must be named after
41 # the directory + 'dir' suffix
42 clientdir = $(pkgpythondir)/client
43 hypervisordir = $(pkgpythondir)/hypervisor
44 blockdir = $(pkgpythondir)/block
45 httpdir = $(pkgpythondir)/http
46 masterddir = $(pkgpythondir)/masterd
47 confddir = $(pkgpythondir)/confd
48 rapidir = $(pkgpythondir)/rapi
49 serverdir = $(pkgpythondir)/server
50 watcherdir = $(pkgpythondir)/watcher
51 impexpddir = $(pkgpythondir)/impexpd
52 utilsdir = $(pkgpythondir)/utils
53 toolsdir = $(pkglibdir)/tools
54 iallocatorsdir = $(pkglibdir)/iallocators
55 pytoolsdir = $(pkgpythondir)/tools
56 docdir = $(datadir)/doc/$(PACKAGE)
57 myexeclibdir = $(pkglibdir)
58
59 # Delete output file if an error occurred while building it
60 .DELETE_ON_ERROR:
61
62 HS_DIRS = \
63         src \
64         src/Ganeti \
65         src/Ganeti/Block \
66         src/Ganeti/Block/Drbd \
67         src/Ganeti/Confd \
68         src/Ganeti/Curl \
69         src/Ganeti/DataCollectors \
70         src/Ganeti/HTools \
71         src/Ganeti/HTools/Backend \
72         src/Ganeti/HTools/Program \
73         src/Ganeti/Hypervisor \
74         src/Ganeti/Hypervisor/Xen \
75         src/Ganeti/Monitoring \
76         src/Ganeti/Query \
77         test/hs \
78         test/hs/Test \
79         test/hs/Test/Ganeti \
80         test/hs/Test/Ganeti/Block \
81         test/hs/Test/Ganeti/Block/Drbd \
82         test/hs/Test/Ganeti/Confd \
83         test/hs/Test/Ganeti/HTools \
84         test/hs/Test/Ganeti/HTools/Backend \
85         test/hs/Test/Ganeti/Hypervisor \
86         test/hs/Test/Ganeti/Hypervisor/Xen \
87         test/hs/Test/Ganeti/Query
88
89 # Haskell directories without the roots (src, test/hs)
90 HS_DIRS_NOROOT = $(filter-out src,$(filter-out test/hs,$(HS_DIRS)))
91
92 DIRS = \
93         $(HS_DIRS) \
94         autotools \
95         daemons \
96         devel \
97         devel/data \
98         doc \
99         doc/css \
100         doc/examples \
101         doc/examples/gnt-debug \
102         doc/examples/hooks \
103         test/data/htools \
104         test/data/htools/rapi \
105         test/hs/shelltests \
106         lib \
107         lib/build \
108         lib/client \
109         lib/confd \
110         lib/http \
111         lib/hypervisor \
112         lib/block \
113         lib/impexpd \
114         lib/masterd \
115         lib/rapi \
116         lib/server \
117         lib/tools \
118         lib/utils \
119         lib/watcher \
120         man \
121         qa \
122         test \
123         test/data \
124         test/data/bdev-rbd \
125         test/data/ovfdata \
126         test/data/ovfdata/other \
127         test/py \
128         tools
129
130 ALL_APIDOC_HS_DIRS = \
131         $(APIDOC_HS_DIR) \
132         $(patsubst %,$(APIDOC_HS_DIR)/%,$(call strip_hsroot,$(HS_DIRS_NOROOT)))
133
134 BUILDTIME_DIR_AUTOCREATE = \
135         scripts \
136         $(APIDOC_DIR) \
137         $(ALL_APIDOC_HS_DIRS) \
138         $(APIDOC_PY_DIR) \
139         $(COVERAGE_DIR) \
140         $(COVERAGE_HS_DIR) \
141         $(COVERAGE_PY_DIR) \
142         .hpc
143
144 BUILDTIME_DIRS = \
145         $(BUILDTIME_DIR_AUTOCREATE) \
146         doc/html \
147         doc/man-html
148
149 DIRCHECK_EXCLUDE = \
150         $(BUILDTIME_DIRS) \
151         ganeti-[0-9]*.[0-9]*.[0-9]* \
152         doc/html/_* \
153         doc/man-html/_* \
154         autom4te.cache
155
156 # some helper vars
157 COVERAGE_DIR = doc/coverage
158 COVERAGE_PY_DIR = $(COVERAGE_DIR)/py
159 COVERAGE_HS_DIR = $(COVERAGE_DIR)/hs
160 APIDOC_DIR = doc/api
161 APIDOC_PY_DIR = $(APIDOC_DIR)/py
162 APIDOC_HS_DIR = $(APIDOC_DIR)/hs
163
164 MAINTAINERCLEANFILES = \
165         $(maninput) \
166         doc/install-quick.rst \
167         doc/news.rst \
168         doc/upgrade.rst \
169         vcs-version
170
171 maintainer-clean-local:
172         rm -rf $(BUILDTIME_DIRS)
173
174 CLEANFILES = \
175         $(addsuffix /*.py[co],$(DIRS)) \
176         $(addsuffix /*.hi,$(HS_DIRS)) \
177         $(addsuffix /*.o,$(HS_DIRS)) \
178         $(PYTHON_BOOTSTRAP) \
179         epydoc.conf \
180         $(REPLACE_VARS_SED) \
181         $(SHELL_ENV_INIT) \
182         daemons/daemon-util \
183         daemons/ganeti-cleaner \
184         devel/squeeze-amd64.tar.gz \
185         devel/squeeze-amd64.conf \
186         $(mandocrst) \
187         doc/manpages-enabled.rst \
188         $(BUILT_EXAMPLES) \
189         doc/examples/bash_completion \
190         doc/examples/bash_completion-debug \
191         lib/_generated_rpc.py \
192         $(man_MANS) \
193         $(manhtml) \
194         tools/kvm-ifup \
195         tools/users-setup \
196         tools/vcluster-setup \
197         stamp-directories \
198         stamp-srclinks \
199         $(nodist_pkgpython_PYTHON) \
200         $(HS_ALL_PROGS) $(HS_BUILT_SRCS) \
201         $(HS_BUILT_TEST_HELPERS) \
202         src/ganeti-confd \
203         src/ganeti-mond \
204         .hpc/*.mix src/*.tix test/hs/*.tix \
205         doc/hs-lint.html
206
207 GENERATED_FILES = \
208         $(built_base_sources) \
209         $(BUILT_PYTHON_SOURCES) \
210         $(PYTHON_BOOTSTRAP)
211
212 HS_GENERATED_FILES =
213 if WANT_HTOOLS
214 HS_GENERATED_FILES += $(HS_PROGS)
215 if ENABLE_CONFD
216 HS_GENERATED_FILES += src/hconfd src/ganeti-confd
217 endif
218
219 if ENABLE_MOND
220 HS_GENERATED_FILES += src/ganeti-mond
221 endif
222 endif
223
224 built_base_sources = \
225         stamp-directories \
226         stamp-srclinks
227
228 built_python_base_sources = \
229         lib/_autoconf.py \
230         lib/_vcsversion.py
231
232 BUILT_PYTHON_SOURCES = \
233         $(built_python_base_sources) \
234         lib/_generated_rpc.py
235
236 # Generating the RPC wrappers depends on many things, so make sure
237 # it's built at the end of the built sources
238 lib/_generated_rpc.py: | $(built_base_sources) $(built_python_base_sources)
239
240 # these are all built from the underlying %.in sources
241 BUILT_EXAMPLES = \
242         doc/examples/ganeti-kvm-poweroff.initd \
243         doc/examples/ganeti.cron \
244         doc/examples/ganeti.initd \
245         doc/examples/ganeti-master-role.ocf \
246         doc/examples/ganeti-node-role.ocf \
247         doc/examples/gnt-config-backup \
248         doc/examples/hooks/ipsec
249
250 nodist_pkgpython_PYTHON = \
251         $(BUILT_PYTHON_SOURCES)
252
253 noinst_PYTHON = \
254         lib/build/__init__.py \
255         lib/build/shell_example_lexer.py \
256         lib/build/sphinx_ext.py
257
258 pkgpython_PYTHON = \
259         lib/__init__.py \
260         lib/asyncnotifier.py \
261         lib/backend.py \
262         lib/bootstrap.py \
263         lib/cli.py \
264         lib/cmdlib.py \
265         lib/compat.py \
266         lib/config.py \
267         lib/constants.py \
268         lib/daemon.py \
269         lib/errors.py \
270         lib/hooksmaster.py \
271         lib/ht.py \
272         lib/jqueue.py \
273         lib/jstore.py \
274         lib/locking.py \
275         lib/luxi.py \
276         lib/mcpu.py \
277         lib/netutils.py \
278         lib/objects.py \
279         lib/opcodes.py \
280         lib/outils.py \
281         lib/ovf.py \
282         lib/pathutils.py \
283         lib/qlang.py \
284         lib/query.py \
285         lib/rpc.py \
286         lib/rpc_defs.py \
287         lib/runtime.py \
288         lib/serializer.py \
289         lib/ssconf.py \
290         lib/ssh.py \
291         lib/storage.py \
292         lib/uidpool.py \
293         lib/vcluster.py \
294         lib/network.py \
295         lib/workerpool.py
296
297 client_PYTHON = \
298         lib/client/__init__.py \
299         lib/client/gnt_backup.py \
300         lib/client/gnt_cluster.py \
301         lib/client/gnt_debug.py \
302         lib/client/gnt_group.py \
303         lib/client/gnt_instance.py \
304         lib/client/gnt_job.py \
305         lib/client/gnt_node.py \
306         lib/client/gnt_network.py \
307         lib/client/gnt_os.py \
308         lib/client/gnt_storage.py
309
310 hypervisor_PYTHON = \
311         lib/hypervisor/__init__.py \
312         lib/hypervisor/hv_base.py \
313         lib/hypervisor/hv_chroot.py \
314         lib/hypervisor/hv_fake.py \
315         lib/hypervisor/hv_kvm.py \
316         lib/hypervisor/hv_lxc.py \
317         lib/hypervisor/hv_xen.py
318
319 block_PYTHON = \
320         lib/block/__init__.py \
321         lib/block/bdev.py \
322         lib/block/base.py \
323         lib/block/drbd.py \
324         lib/block/drbd_info.py \
325         lib/block/drbd_cmdgen.py
326
327 rapi_PYTHON = \
328         lib/rapi/__init__.py \
329         lib/rapi/baserlib.py \
330         lib/rapi/client.py \
331         lib/rapi/client_utils.py \
332         lib/rapi/connector.py \
333         lib/rapi/rlib2.py \
334         lib/rapi/testutils.py
335
336 http_PYTHON = \
337         lib/http/__init__.py \
338         lib/http/auth.py \
339         lib/http/client.py \
340         lib/http/server.py
341
342 confd_PYTHON = \
343         lib/confd/__init__.py \
344         lib/confd/client.py
345
346 masterd_PYTHON = \
347         lib/masterd/__init__.py \
348         lib/masterd/iallocator.py \
349         lib/masterd/instance.py
350
351 impexpd_PYTHON = \
352         lib/impexpd/__init__.py
353
354 watcher_PYTHON = \
355         lib/watcher/__init__.py \
356         lib/watcher/nodemaint.py \
357         lib/watcher/state.py
358
359 server_PYTHON = \
360         lib/server/__init__.py \
361         lib/server/masterd.py \
362         lib/server/noded.py \
363         lib/server/rapi.py
364
365 pytools_PYTHON = \
366         lib/tools/__init__.py \
367         lib/tools/burnin.py \
368         lib/tools/ensure_dirs.py \
369         lib/tools/node_cleanup.py \
370         lib/tools/node_daemon_setup.py \
371         lib/tools/prepare_node_join.py
372
373 utils_PYTHON = \
374         lib/utils/__init__.py \
375         lib/utils/algo.py \
376         lib/utils/filelock.py \
377         lib/utils/hash.py \
378         lib/utils/io.py \
379         lib/utils/log.py \
380         lib/utils/lvm.py \
381         lib/utils/mlock.py \
382         lib/utils/nodesetup.py \
383         lib/utils/process.py \
384         lib/utils/retry.py \
385         lib/utils/storage.py \
386         lib/utils/text.py \
387         lib/utils/wrapper.py \
388         lib/utils/x509.py
389
390 docinput = \
391         doc/conf.py \
392         doc/css/style.css \
393         doc/admin.rst \
394         doc/cluster-merge.rst \
395         doc/design-2.0.rst \
396         doc/design-2.1.rst \
397         doc/design-2.2.rst \
398         doc/design-2.3.rst \
399         doc/design-2.4.rst \
400         doc/design-2.5.rst \
401         doc/design-2.6.rst \
402         doc/design-2.7.rst \
403         doc/design-autorepair.rst \
404         doc/design-bulk-create.rst \
405         doc/design-chained-jobs.rst \
406         doc/design-cpu-pinning.rst \
407         doc/design-device-uuid-name.rst \
408         doc/design-draft.rst \
409         doc/design-htools-2.3.rst \
410         doc/design-http-server.rst \
411         doc/design-impexp2.rst \
412         doc/design-lu-generated-jobs.rst \
413         doc/design-linuxha.rst \
414         doc/design-multi-reloc.rst \
415         doc/design-network.rst \
416         doc/design-node-add.rst \
417         doc/design-oob.rst \
418         doc/design-ovf-support.rst \
419         doc/design-opportunistic-locking.rst \
420         doc/design-partitioned.rst \
421         doc/design-query-splitting.rst \
422         doc/design-query2.rst \
423         doc/design-reason-trail.rst \
424         doc/design-resource-model.rst \
425         doc/design-restricted-commands.rst \
426         doc/design-shared-storage.rst \
427         doc/design-monitoring-agent.rst \
428         doc/design-virtual-clusters.rst \
429         doc/design-x509-ca.rst \
430         doc/design-hroller.rst \
431         doc/design-storagetypes.rst \
432         doc/devnotes.rst \
433         doc/glossary.rst \
434         doc/hooks.rst \
435         doc/iallocator.rst \
436         doc/index.rst \
437         doc/install-quick.rst \
438         doc/install.rst \
439         doc/locking.rst \
440         doc/manpages-disabled.rst \
441         doc/move-instance.rst \
442         doc/news.rst \
443         doc/ovfconverter.rst \
444         doc/rapi.rst \
445         doc/security.rst \
446         doc/upgrade.rst \
447         doc/virtual-cluster.rst \
448         doc/walkthrough.rst
449
450 # Generates file names such as "doc/man-gnt-instance.rst"
451 mandocrst = $(addprefix doc/man-,$(notdir $(manrst)))
452
453 # Haskell programs to be installed in $PREFIX/bin
454 HS_BIN_PROGS=src/htools
455
456 # Haskell programs to be installed in the MYEXECLIB dir
457 if ENABLE_MOND
458 HS_MYEXECLIB_PROGS=src/mon-collector
459 else
460 HS_MYEXECLIB_PROGS=
461 endif
462
463 # Haskell programs to be compiled by "make really-all"
464 HS_COMPILE_PROGS= \
465         src/ganeti-mond \
466         src/hconfd \
467         src/rpc-test
468
469 # All Haskell non-test programs to be compiled but not automatically installed
470 HS_PROGS = $(HS_BIN_PROGS) $(HS_MYEXECLIB_PROGS)
471
472 HS_BIN_ROLES = harep hbal hscan hspace hinfo hcheck hroller
473 HS_HTOOLS_PROGS = $(HS_BIN_ROLES) hail
474
475 HS_ALL_PROGS = \
476         $(HS_PROGS) \
477         test/hs/hpc-htools \
478         test/hs/hpc-mon-collector \
479         test/hs/htest \
480         $(HS_COMPILE_PROGS)
481
482 HS_PROG_SRCS = $(patsubst %,%.hs,$(HS_ALL_PROGS))
483 HS_BUILT_TEST_HELPERS = $(HS_BIN_ROLES:%=test/hs/%) test/hs/hail
484
485 HFLAGS = \
486         -O -Wall -Werror -isrc \
487         -fwarn-monomorphism-restriction \
488         -fwarn-tabs \
489         $(GHC_BYVERSION_FLAGS)
490
491 # extra flags that can be overriden on the command line (e.g. -Wwarn, etc.)
492 HEXTRA =
493 # internal extra flags (used for test/hs/htest mainly)
494 HEXTRA_INT =
495 # exclude options for coverage reports
496 HPCEXCL = --exclude Main \
497         --exclude Ganeti.Constants \
498         --exclude Ganeti.HTools.QC \
499         --exclude Ganeti.THH \
500         --exclude Ganeti.Version \
501         --exclude Test.Ganeti.Attoparsec \
502         --exclude Test.Ganeti.TestCommon \
503         --exclude Test.Ganeti.TestHTools \
504         --exclude Test.Ganeti.TestHelper \
505         --exclude Test.Ganeti.TestImports \
506         $(patsubst src.%,--exclude Test.%,$(subst /,.,$(patsubst %.hs,%, $(HS_LIB_SRCS))))
507
508 HS_LIB_SRCS = \
509         src/Ganeti/Block/Drbd/Types.hs \
510         src/Ganeti/Block/Drbd/Parser.hs \
511         src/Ganeti/BasicTypes.hs \
512         src/Ganeti/Common.hs \
513         src/Ganeti/Compat.hs \
514         src/Ganeti/Confd/Client.hs \
515         src/Ganeti/Confd/Server.hs \
516         src/Ganeti/Confd/Types.hs \
517         src/Ganeti/Confd/Utils.hs \
518         src/Ganeti/Config.hs \
519         src/Ganeti/Curl/Multi.hs \
520         src/Ganeti/Daemon.hs \
521         src/Ganeti/DataCollectors/CLI.hs \
522         src/Ganeti/DataCollectors/Drbd.hs \
523         src/Ganeti/DataCollectors/InstStatus.hs \
524         src/Ganeti/DataCollectors/InstStatusTypes.hs \
525         src/Ganeti/DataCollectors/Program.hs \
526         src/Ganeti/DataCollectors/Types.hs \
527         src/Ganeti/Errors.hs \
528         src/Ganeti/HTools/Backend/IAlloc.hs \
529         src/Ganeti/HTools/Backend/Luxi.hs \
530         src/Ganeti/HTools/Backend/Rapi.hs \
531         src/Ganeti/HTools/Backend/Simu.hs \
532         src/Ganeti/HTools/Backend/Text.hs \
533         src/Ganeti/HTools/CLI.hs \
534         src/Ganeti/HTools/Cluster.hs \
535         src/Ganeti/HTools/Container.hs \
536         src/Ganeti/HTools/ExtLoader.hs \
537         src/Ganeti/HTools/Graph.hs \
538         src/Ganeti/HTools/Group.hs \
539         src/Ganeti/HTools/Instance.hs \
540         src/Ganeti/HTools/Loader.hs \
541         src/Ganeti/HTools/Node.hs \
542         src/Ganeti/HTools/PeerMap.hs \
543         src/Ganeti/HTools/Program/Hail.hs \
544         src/Ganeti/HTools/Program/Harep.hs \
545         src/Ganeti/HTools/Program/Hbal.hs \
546         src/Ganeti/HTools/Program/Hcheck.hs \
547         src/Ganeti/HTools/Program/Hinfo.hs \
548         src/Ganeti/HTools/Program/Hscan.hs \
549         src/Ganeti/HTools/Program/Hspace.hs \
550         src/Ganeti/HTools/Program/Hroller.hs \
551         src/Ganeti/HTools/Program/Main.hs \
552         src/Ganeti/HTools/Types.hs \
553         src/Ganeti/Hypervisor/Xen.hs \
554         src/Ganeti/Hypervisor/Xen/XmParser.hs \
555         src/Ganeti/Hypervisor/Xen/Types.hs \
556         src/Ganeti/Hash.hs \
557         src/Ganeti/JQueue.hs \
558         src/Ganeti/JSON.hs \
559         src/Ganeti/Jobs.hs \
560         src/Ganeti/Logging.hs \
561         src/Ganeti/Luxi.hs \
562         src/Ganeti/Monitoring/Server.hs \
563         src/Ganeti/Network.hs \
564         src/Ganeti/Objects.hs \
565         src/Ganeti/OpCodes.hs \
566         src/Ganeti/OpParams.hs \
567         src/Ganeti/Path.hs \
568         src/Ganeti/Query/Common.hs \
569         src/Ganeti/Query/Export.hs \
570         src/Ganeti/Query/Filter.hs \
571         src/Ganeti/Query/Group.hs \
572         src/Ganeti/Query/Job.hs \
573         src/Ganeti/Query/Language.hs \
574         src/Ganeti/Query/Network.hs \
575         src/Ganeti/Query/Node.hs \
576         src/Ganeti/Query/Query.hs \
577         src/Ganeti/Query/Server.hs \
578         src/Ganeti/Query/Types.hs \
579         src/Ganeti/Rpc.hs \
580         src/Ganeti/Runtime.hs \
581         src/Ganeti/Ssconf.hs \
582         src/Ganeti/THH.hs \
583         src/Ganeti/Types.hs \
584         src/Ganeti/Utils.hs
585
586 HS_TEST_SRCS = \
587         test/hs/Test/Ganeti/Attoparsec.hs \
588         test/hs/Test/Ganeti/BasicTypes.hs \
589         test/hs/Test/Ganeti/Block/Drbd/Parser.hs \
590         test/hs/Test/Ganeti/Block/Drbd/Types.hs \
591         test/hs/Test/Ganeti/Common.hs \
592         test/hs/Test/Ganeti/Confd/Types.hs \
593         test/hs/Test/Ganeti/Confd/Utils.hs \
594         test/hs/Test/Ganeti/Daemon.hs \
595         test/hs/Test/Ganeti/Errors.hs \
596         test/hs/Test/Ganeti/HTools/Backend/Simu.hs \
597         test/hs/Test/Ganeti/HTools/Backend/Text.hs \
598         test/hs/Test/Ganeti/HTools/CLI.hs \
599         test/hs/Test/Ganeti/HTools/Cluster.hs \
600         test/hs/Test/Ganeti/HTools/Container.hs \
601         test/hs/Test/Ganeti/HTools/Graph.hs \
602         test/hs/Test/Ganeti/HTools/Instance.hs \
603         test/hs/Test/Ganeti/HTools/Loader.hs \
604         test/hs/Test/Ganeti/HTools/Node.hs \
605         test/hs/Test/Ganeti/HTools/PeerMap.hs \
606         test/hs/Test/Ganeti/HTools/Types.hs \
607         test/hs/Test/Ganeti/Hypervisor/Xen/XmParser.hs \
608         test/hs/Test/Ganeti/JSON.hs \
609         test/hs/Test/Ganeti/Jobs.hs \
610         test/hs/Test/Ganeti/JQueue.hs \
611         test/hs/Test/Ganeti/Luxi.hs \
612         test/hs/Test/Ganeti/Network.hs \
613         test/hs/Test/Ganeti/Objects.hs \
614         test/hs/Test/Ganeti/OpCodes.hs \
615         test/hs/Test/Ganeti/Query/Filter.hs \
616         test/hs/Test/Ganeti/Query/Language.hs \
617         test/hs/Test/Ganeti/Query/Network.hs \
618         test/hs/Test/Ganeti/Query/Query.hs \
619         test/hs/Test/Ganeti/Rpc.hs \
620         test/hs/Test/Ganeti/Runtime.hs \
621         test/hs/Test/Ganeti/Ssconf.hs \
622         test/hs/Test/Ganeti/THH.hs \
623         test/hs/Test/Ganeti/TestCommon.hs \
624         test/hs/Test/Ganeti/TestHTools.hs \
625         test/hs/Test/Ganeti/TestHelper.hs \
626         test/hs/Test/Ganeti/Types.hs \
627         test/hs/Test/Ganeti/Utils.hs
628
629 HS_LIBTEST_SRCS = $(HS_LIB_SRCS) $(HS_TEST_SRCS)
630
631 HS_BUILT_SRCS = \
632         test/hs/Test/Ganeti/TestImports.hs \
633         src/Ganeti/Constants.hs \
634         src/Ganeti/Curl/Internal.hs \
635         src/Ganeti/Version.hs
636 HS_BUILT_SRCS_IN = \
637         $(patsubst %,%.in,$(filter-out src/Ganeti/Curl/Internal.hs,$(HS_BUILT_SRCS))) \
638         src/Ganeti/Curl/Internal.hsc
639
640 HS_LIBTESTBUILT_SRCS = $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS)
641
642 $(RUN_IN_TEMPDIR): | stamp-directories
643
644 doc/html/index.html: ENABLE_MANPAGES =
645 doc/man-html/index.html: ENABLE_MANPAGES = 1
646 doc/man-html/index.html: doc/manpages-enabled.rst $(mandocrst)
647
648 # Note: we use here an order-only prerequisite, as the contents of
649 # _autoconf.py are not actually influencing the html build output: it
650 # has to exist in order for the sphinx module to be loaded
651 # successfully, but we certainly don't want the docs to be rebuilt if
652 # it changes
653 doc/html/index.html doc/man-html/index.html: $(docinput) doc/conf.py \
654         configure.ac $(RUN_IN_TEMPDIR) lib/build/sphinx_ext.py \
655         lib/build/shell_example_lexer.py lib/opcodes.py lib/ht.py \
656         doc/css/style.css lib/rapi/connector.py lib/rapi/rlib2.py \
657         | $(BUILT_PYTHON_SOURCES)
658         @test -n "$(SPHINX)" || \
659             { echo 'sphinx-build' not found during configure; exit 1; }
660 if !MANPAGES_IN_DOC
661         if test -n '$(ENABLE_MANPAGES)'; then \
662           echo 'Man pages in documentation were disabled at configure time' >&2; \
663           exit 1; \
664         fi
665 endif
666 ## Sphinx provides little control over what content should be included. Some
667 ## mechanisms exist, but they all have drawbacks or actual issues. Since we
668 ## build two different versions of the documentation--once without man pages and
669 ## once, if enabled, with them--some control is necessary. xmpp-wrapper provides
670 ## us with this, but requires running in a temporary directory. It moves the
671 ## correct files into place depending on environment variables.
672         dir=$(dir $@) && \
673         @mkdir_p@ $$dir && \
674         PYTHONPATH=. ENABLE_MANPAGES=$(ENABLE_MANPAGES) COPY_DOC=1 \
675         $(RUN_IN_TEMPDIR) autotools/sphinx-wrapper $(SPHINX) -q -W -b html \
676             -d . \
677             -D version="$(VERSION_MAJOR).$(VERSION_MINOR)" \
678             -D release="$(PACKAGE_VERSION)" \
679             -D graphviz_dot="$(DOT)" \
680             -D enable_manpages="$(ENABLE_MANPAGES)" \
681             doc $(CURDIR)/$$dir && \
682         rm -f $$dir/.buildinfo $$dir/objects.inv
683         touch $@
684
685 doc/html: doc/html/index.html
686
687 doc/man-html: doc/man-html/index.html
688
689 doc/install-quick.rst: INSTALL
690 doc/news.rst: NEWS
691 doc/upgrade.rst: UPGRADE
692
693 doc/install-quick.rst doc/news.rst doc/upgrade.rst:
694         set -e; \
695         { echo '.. This file is automatically updated at build time from $<.'; \
696           echo '.. Do not edit.'; \
697           echo; \
698           cat $<; \
699         } > $@
700
701 doc/manpages-enabled.rst: Makefile | $(built_base_sources)
702         { echo '.. This file is automatically generated, do not edit!'; \
703           echo ''; \
704           echo 'Man pages'; \
705           echo '========='; \
706           echo; \
707           echo '.. toctree::'; \
708           echo '   :maxdepth: 1'; \
709           echo; \
710           for i in $(notdir $(mandocrst)); do \
711             echo "   $$i"; \
712           done | LC_ALL=C sort; \
713         } > $@
714
715 doc/man-%.rst: man/%.gen Makefile $(REPLACE_VARS_SED) | $(built_base_sources)
716 if MANPAGES_IN_DOC
717         { echo '.. This file is automatically updated at build time from $<.'; \
718           echo '.. Do not edit.'; \
719           echo; \
720           echo "$*"; \
721           echo '=========================================='; \
722           tail -n +3 $< | sed -f $(REPLACE_VARS_SED); \
723         } > $@
724 else
725         echo 'Man pages in documentation were disabled at configure time' >&2; \
726         exit 1;
727 endif
728
729 # Things to build but not to install (add it to EXTRA_DIST if it should be
730 # distributed)
731 noinst_DATA = \
732         doc/html \
733         $(BUILT_EXAMPLES) \
734         doc/examples/bash_completion \
735         doc/examples/bash_completion-debug \
736         $(manhtml)
737
738 if MANPAGES_IN_DOC
739 noinst_DATA += doc/man-html
740 endif
741
742 gnt_scripts = \
743         scripts/gnt-backup \
744         scripts/gnt-cluster \
745         scripts/gnt-debug \
746         scripts/gnt-group \
747         scripts/gnt-instance \
748         scripts/gnt-job \
749         scripts/gnt-network \
750         scripts/gnt-node \
751         scripts/gnt-os \
752         scripts/gnt-storage
753
754 PYTHON_BOOTSTRAP_SBIN = \
755         daemons/ganeti-masterd \
756         daemons/ganeti-noded \
757         daemons/ganeti-rapi \
758         daemons/ganeti-watcher \
759         $(gnt_scripts)
760
761 PYTHON_BOOTSTRAP = \
762         $(PYTHON_BOOTSTRAP_SBIN) \
763         tools/burnin \
764         tools/ensure-dirs \
765         tools/node-cleanup \
766         tools/node-daemon-setup \
767         tools/prepare-node-join
768
769 qa_scripts = \
770         qa/__init__.py \
771         qa/ganeti-qa.py \
772         qa/qa_cluster.py \
773         qa/qa_config.py \
774         qa/qa_daemon.py \
775         qa/qa_env.py \
776         qa/qa_error.py \
777         qa/qa_group.py \
778         qa/qa_instance.py \
779         qa/qa_job.py \
780         qa/qa_node.py \
781         qa/qa_os.py \
782         qa/qa_rapi.py \
783         qa/qa_tags.py \
784         qa/qa_utils.py
785
786 bin_SCRIPTS =
787 if WANT_HTOOLS
788 bin_SCRIPTS += $(HS_BIN_PROGS)
789 install-exec-hook:
790         @mkdir_p@ $(DESTDIR)$(iallocatorsdir)
791 # FIXME: this is a hardcoded logic, instead of auto-resolving
792         $(LN_S) -f ../../../bin/htools \
793           $(DESTDIR)$(iallocatorsdir)/hail
794         for role in $(HS_BIN_ROLES); do \
795           $(LN_S) -f htools $(DESTDIR)$(bindir)/$$role ; \
796         done
797 endif
798
799 $(HS_ALL_PROGS): %: %.hs $(HS_LIBTESTBUILT_SRCS) Makefile
800         @if [ "$(notdir $@)" = "test" ] && [ "$(HS_NODEV)" ]; then \
801           echo "Error: cannot run unittests without the development" \
802                " libraries (see devnotes.rst)" 1>&2; \
803           exit 1; \
804         fi
805         @rm -f $(notdir $@).tix
806         $(GHC) --make \
807           $(HFLAGS) \
808           $(HS_PARALLEL3) $(HS_REGEX_PCRE) \
809           -osuf $(notdir $@).o -hisuf $(notdir $@).hi \
810           $(HEXTRA) $(HEXTRA_INT) $@
811         @touch "$@"
812
813 # for the test/hs/htest binary, we need to enable profiling/coverage
814 test/hs/htest: HEXTRA_INT=-fhpc -itest/hs
815
816 # we compile the hpc-htools binary with the program coverage
817 test/hs/hpc-htools: HEXTRA_INT=-fhpc
818
819 # we compile the hpc-mon-collector binary with the program coverage
820 test/hs/hpc-mon-collector: HEXTRA_INT=-fhpc
821
822 # test dependency
823 test/hs/offline-tests.sh: test/hs/hpc-htools test/hs/hpc-mon-collector
824
825 # rules for building profiling-enabled versions of the haskell
826 # programs: hs-prof does the full two-step build, whereas
827 # hs-prof-quick does only the final rebuild (hs-prof must have been
828 # run before)
829 .PHONY: hs-prof hs-prof-quick
830 hs-prof:
831         @if [ -z "$(TARGET)" ]; then \
832           echo "You need to define TARGET when running this rule" 1>&2; \
833           exit 1; \
834         fi
835         $(MAKE) $(AM_MAKEFLAGS) clean
836         $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf o"
837         rm -f $(HS_ALL_PROGS)
838         $(MAKE) $(AM_MAKEFLAGS) hs-prof-quick
839
840 hs-prof-quick:
841         @if [ -z "$(TARGET)" ]; then \
842           echo "You need to define TARGET when running this rule" 1>&2; \
843           exit 1; \
844         fi
845         $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf prof_o -prof -auto-all"
846
847 dist_sbin_SCRIPTS = \
848         tools/ganeti-listrunner
849
850 nodist_sbin_SCRIPTS = \
851         $(PYTHON_BOOTSTRAP_SBIN) \
852         daemons/ganeti-cleaner
853
854 if ENABLE_CONFD
855 src/ganeti-confd: src/hconfd
856         cp -f $< $@
857
858 nodist_sbin_SCRIPTS += src/ganeti-confd
859 endif
860
861 if ENABLE_MOND
862 nodist_sbin_SCRIPTS += src/ganeti-mond
863 endif
864
865 python_scripts = \
866         tools/cfgshell \
867         tools/cfgupgrade \
868         tools/cfgupgrade12 \
869         tools/cluster-merge \
870         tools/confd-client \
871         tools/fmtjson \
872         tools/lvmstrap \
873         tools/move-instance \
874         tools/ovfconverter \
875         tools/sanitize-config
876
877 dist_tools_SCRIPTS = \
878         $(python_scripts) \
879         tools/burnin \
880         tools/kvm-console-wrapper \
881         tools/master-ip-setup \
882         tools/xen-console-wrapper
883
884 nodist_tools_python_scripts = \
885         tools/node-cleanup
886
887 nodist_tools_SCRIPTS = \
888         $(nodist_tools_python_scripts) \
889         tools/users-setup \
890         tools/vcluster-setup
891
892 pkglib_python_scripts = \
893         daemons/import-export \
894         tools/check-cert-expired
895
896 nodist_pkglib_python_scripts = \
897         tools/ensure-dirs \
898         tools/node-daemon-setup \
899         tools/prepare-node-join
900
901 myexeclib_SCRIPTS = \
902         daemons/daemon-util \
903         tools/kvm-ifup \
904         $(pkglib_python_scripts) \
905         $(HS_MYEXECLIB_PROGS)
906
907 nodist_myexeclib_SCRIPTS = \
908         $(nodist_pkglib_python_scripts)
909
910 EXTRA_DIST = \
911         NEWS \
912         UPGRADE \
913         epydoc.conf.in \
914         pylintrc \
915         autotools/build-bash-completion \
916         autotools/build-rpc \
917         autotools/check-header \
918         autotools/check-imports \
919         autotools/check-man-dashes \
920         autotools/check-man-references \
921         autotools/check-man-warnings \
922         autotools/check-news \
923         autotools/check-python-code \
924         autotools/check-tar \
925         autotools/check-version \
926         autotools/convert-constants \
927         autotools/docpp \
928         autotools/gen-py-coverage \
929         autotools/sphinx-wrapper \
930         autotools/testrunner \
931         autotools/wrong-hardcoded-paths \
932         $(RUN_IN_TEMPDIR) \
933         daemons/daemon-util.in \
934         daemons/ganeti-cleaner.in \
935         $(pkglib_python_scripts) \
936         devel/upload \
937         devel/webserver \
938         tools/kvm-ifup.in \
939         tools/users-setup.in \
940         tools/vcluster-setup.in \
941         $(docinput) \
942         doc/html \
943         $(BUILT_EXAMPLES:%=%.in) \
944         doc/examples/ganeti.default \
945         doc/examples/ganeti.default-debug \
946         doc/examples/hooks/ethers \
947         doc/examples/gnt-debug/README \
948         doc/examples/gnt-debug/delay0.json \
949         doc/examples/gnt-debug/delay50.json \
950         test/py/lockperf.py \
951         test/py/testutils.py \
952         test/py/mocks.py \
953         $(dist_TESTS) \
954         $(TEST_FILES) \
955         man/footer.rst \
956         $(manrst) \
957         $(maninput) \
958         qa/qa-sample.json \
959         $(qa_scripts) \
960         $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS_IN) \
961         $(HS_PROG_SRCS) \
962         src/lint-hints.hs \
963         test/hs/cli-tests-defs.sh \
964         test/hs/offline-test.sh \
965         .ghci
966
967 man_MANS = \
968         man/ganeti-cleaner.8 \
969         man/ganeti-confd.8 \
970         man/ganeti-listrunner.8 \
971         man/ganeti-masterd.8 \
972         man/ganeti-mond.8 \
973         man/ganeti-noded.8 \
974         man/ganeti-os-interface.7 \
975         man/ganeti-extstorage-interface.7 \
976         man/ganeti-rapi.8 \
977         man/ganeti-watcher.8 \
978         man/ganeti.7 \
979         man/gnt-backup.8 \
980         man/gnt-cluster.8 \
981         man/gnt-debug.8 \
982         man/gnt-group.8 \
983         man/gnt-network.8 \
984         man/gnt-instance.8 \
985         man/gnt-job.8 \
986         man/gnt-node.8 \
987         man/gnt-os.8 \
988         man/gnt-storage.8 \
989         man/hail.1 \
990         man/hbal.1 \
991         man/hcheck.1 \
992         man/hinfo.1 \
993         man/hscan.1 \
994         man/hspace.1 \
995         man/hroller.1 \
996         man/htools.1 \
997         man/mon-collector.7
998
999 # Remove extensions from all filenames in man_MANS
1000 mannoext = $(patsubst %.1,%,$(patsubst %.7,%,$(patsubst %.8,%,$(man_MANS))))
1001
1002 manrst = $(patsubst %,%.rst,$(mannoext))
1003 manhtml = $(patsubst %.rst,%.html,$(manrst))
1004 mangen = $(patsubst %.rst,%.gen,$(manrst))
1005 maninput = \
1006         $(patsubst %.1,%.1.in,$(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS)))) \
1007         $(patsubst %.html,%.html.in,$(manhtml)) \
1008         $(mangen)
1009
1010 TEST_FILES = \
1011         test/data/htools/clean-nonzero-score.data \
1012         test/data/htools/common-suffix.data \
1013         test/data/htools/empty-cluster.data \
1014         test/data/htools/hail-alloc-drbd.json \
1015         test/data/htools/hail-alloc-invalid-twodisks.json \
1016         test/data/htools/hail-alloc-twodisks.json \
1017         test/data/htools/hail-change-group.json \
1018         test/data/htools/hail-invalid-reloc.json \
1019         test/data/htools/hail-node-evac.json \
1020         test/data/htools/hail-reloc-drbd.json \
1021         test/data/htools/hbal-excl-tags.data \
1022         test/data/htools/hbal-split-insts.data \
1023         test/data/htools/hspace-tiered-dualspec.data \
1024         test/data/htools/hspace-tiered.data \
1025         test/data/htools/invalid-node.data \
1026         test/data/htools/missing-resources.data \
1027         test/data/htools/multiple-master.data \
1028         test/data/htools/multiple-tags.data \
1029         test/data/htools/n1-failure.data \
1030         test/data/htools/rapi/groups.json \
1031         test/data/htools/rapi/info.json \
1032         test/data/htools/rapi/instances.json \
1033         test/data/htools/rapi/nodes.json \
1034         test/data/htools/hroller-online.data \
1035         test/data/htools/unique-reboot-order.data \
1036         test/hs/shelltests/htools-balancing.test \
1037         test/hs/shelltests/htools-basic.test \
1038         test/hs/shelltests/htools-dynutil.test \
1039         test/hs/shelltests/htools-excl.test \
1040         test/hs/shelltests/htools-hail.test \
1041         test/hs/shelltests/htools-hroller.test \
1042         test/hs/shelltests/htools-hspace.test \
1043         test/hs/shelltests/htools-invalid.test \
1044         test/hs/shelltests/htools-multi-group.test \
1045         test/hs/shelltests/htools-no-backend.test \
1046         test/hs/shelltests/htools-rapi.test \
1047         test/hs/shelltests/htools-single-group.test \
1048         test/hs/shelltests/htools-text-backend.test \
1049         test/hs/shelltests/htools-mon-collector.test \
1050         test/data/bdev-drbd-8.0.txt \
1051         test/data/bdev-drbd-8.3.txt \
1052         test/data/bdev-drbd-8.4.txt \
1053         test/data/bdev-drbd-disk.txt \
1054         test/data/bdev-drbd-net-ip4.txt \
1055         test/data/bdev-drbd-net-ip6.txt \
1056         test/data/bdev-rbd/json_output_empty.txt \
1057         test/data/bdev-rbd/json_output_extra_matches.txt \
1058         test/data/bdev-rbd/json_output_no_matches.txt \
1059         test/data/bdev-rbd/json_output_ok.txt \
1060         test/data/bdev-rbd/plain_output_new_extra_matches.txt \
1061         test/data/bdev-rbd/plain_output_new_no_matches.txt \
1062         test/data/bdev-rbd/plain_output_new_ok.txt \
1063         test/data/bdev-rbd/plain_output_old_empty.txt \
1064         test/data/bdev-rbd/plain_output_old_extra_matches.txt \
1065         test/data/bdev-rbd/plain_output_old_no_matches.txt \
1066         test/data/bdev-rbd/plain_output_old_ok.txt \
1067         test/data/bdev-rbd/output_invalid.txt \
1068         test/data/cert1.pem \
1069         test/data/cert2.pem \
1070         test/data/cluster_config_2.7.json \
1071         test/data/cluster_config_downgraded_2.7.json \
1072         test/data/instance-minor-pairing.txt \
1073         test/data/ip-addr-show-dummy0.txt \
1074         test/data/ip-addr-show-lo-ipv4.txt \
1075         test/data/ip-addr-show-lo-ipv6.txt \
1076         test/data/ip-addr-show-lo-oneline-ipv4.txt \
1077         test/data/ip-addr-show-lo-oneline-ipv6.txt \
1078         test/data/ip-addr-show-lo-oneline.txt \
1079         test/data/ip-addr-show-lo.txt \
1080         test/data/kvm_0.12.5_help.txt \
1081         test/data/kvm_0.15.90_help.txt \
1082         test/data/kvm_0.9.1_help.txt \
1083         test/data/kvm_0.9.1_help_boot_test.txt \
1084         test/data/kvm_1.0_help.txt \
1085         test/data/kvm_1.1.2_help.txt \
1086         test/data/ovfdata/compr_disk.vmdk.gz \
1087         test/data/ovfdata/config.ini \
1088         test/data/ovfdata/corrupted_resources.ovf \
1089         test/data/ovfdata/empty.ini \
1090         test/data/ovfdata/empty.ovf \
1091         test/data/ovfdata/ganeti.mf \
1092         test/data/ovfdata/ganeti.ovf \
1093         test/data/ovfdata/gzip_disk.ovf \
1094         test/data/ovfdata/new_disk.vmdk \
1095         test/data/ovfdata/no_disk.ini \
1096         test/data/ovfdata/no_disk_in_ref.ovf \
1097         test/data/ovfdata/no_os.ini \
1098         test/data/ovfdata/no_ovf.ova \
1099         test/data/ovfdata/other/rawdisk.raw \
1100         test/data/ovfdata/ova.ova \
1101         test/data/ovfdata/rawdisk.raw \
1102         test/data/ovfdata/second_disk.vmdk \
1103         test/data/ovfdata/unsafe_path.ini \
1104         test/data/ovfdata/virtualbox.ovf \
1105         test/data/ovfdata/wrong_config.ini \
1106         test/data/ovfdata/wrong_extension.ovd \
1107         test/data/ovfdata/wrong_manifest.mf \
1108         test/data/ovfdata/wrong_manifest.ovf \
1109         test/data/ovfdata/wrong_ova.ova \
1110         test/data/ovfdata/wrong_xml.ovf \
1111         test/data/proc_drbd8.txt \
1112         test/data/proc_drbd80-emptyline.txt \
1113         test/data/proc_drbd80-emptyversion.txt \
1114         test/data/proc_drbd83.txt \
1115         test/data/proc_drbd83_sync.txt \
1116         test/data/proc_drbd83_sync_want.txt \
1117         test/data/proc_drbd83_sync_krnl2.6.39.txt \
1118         test/data/proc_drbd84.txt \
1119         test/data/proc_drbd84_sync.txt \
1120         test/data/qa-minimal-nodes-instances-only.json \
1121         test/data/sys_drbd_usermode_helper.txt \
1122         test/data/vgreduce-removemissing-2.02.02.txt \
1123         test/data/vgreduce-removemissing-2.02.66-fail.txt \
1124         test/data/vgreduce-removemissing-2.02.66-ok.txt \
1125         test/data/vgs-missing-pvs-2.02.02.txt \
1126         test/data/vgs-missing-pvs-2.02.66.txt \
1127         test/data/xen-xm-info-4.0.1.txt \
1128         test/data/xen-xm-list-4.0.1-dom0-only.txt \
1129         test/data/xen-xm-list-4.0.1-four-instances.txt \
1130         test/data/xen-xm-list-long-4.0.1.txt \
1131         test/data/xen-xm-uptime-4.0.1.txt \
1132         test/py/ganeti-cli.test \
1133         test/py/gnt-cli.test \
1134         test/py/import-export_unittest-helper
1135
1136 python_tests = \
1137         doc/examples/rapi_testutils.py \
1138         test/py/cfgupgrade_unittest.py \
1139         test/py/docs_unittest.py \
1140         test/py/ganeti.asyncnotifier_unittest.py \
1141         test/py/ganeti.backend_unittest-runasroot.py \
1142         test/py/ganeti.backend_unittest.py \
1143         test/py/ganeti.block.bdev_unittest.py \
1144         test/py/ganeti.block.drbd_unittest.py \
1145         test/py/ganeti.cli_unittest.py \
1146         test/py/ganeti.client.gnt_cluster_unittest.py \
1147         test/py/ganeti.client.gnt_instance_unittest.py \
1148         test/py/ganeti.client.gnt_job_unittest.py \
1149         test/py/ganeti.cmdlib_unittest.py \
1150         test/py/ganeti.compat_unittest.py \
1151         test/py/ganeti.confd.client_unittest.py \
1152         test/py/ganeti.config_unittest.py \
1153         test/py/ganeti.constants_unittest.py \
1154         test/py/ganeti.daemon_unittest.py \
1155         test/py/ganeti.errors_unittest.py \
1156         test/py/ganeti.hooks_unittest.py \
1157         test/py/ganeti.ht_unittest.py \
1158         test/py/ganeti.http_unittest.py \
1159         test/py/ganeti.hypervisor.hv_chroot_unittest.py \
1160         test/py/ganeti.hypervisor.hv_fake_unittest.py \
1161         test/py/ganeti.hypervisor.hv_kvm_unittest.py \
1162         test/py/ganeti.hypervisor.hv_lxc_unittest.py \
1163         test/py/ganeti.hypervisor.hv_xen_unittest.py \
1164         test/py/ganeti.hypervisor_unittest.py \
1165         test/py/ganeti.impexpd_unittest.py \
1166         test/py/ganeti.jqueue_unittest.py \
1167         test/py/ganeti.jstore_unittest.py \
1168         test/py/ganeti.locking_unittest.py \
1169         test/py/ganeti.luxi_unittest.py \
1170         test/py/ganeti.masterd.iallocator_unittest.py \
1171         test/py/ganeti.masterd.instance_unittest.py \
1172         test/py/ganeti.mcpu_unittest.py \
1173         test/py/ganeti.netutils_unittest.py \
1174         test/py/ganeti.objects_unittest.py \
1175         test/py/ganeti.opcodes_unittest.py \
1176         test/py/ganeti.outils_unittest.py \
1177         test/py/ganeti.ovf_unittest.py \
1178         test/py/ganeti.qlang_unittest.py \
1179         test/py/ganeti.query_unittest.py \
1180         test/py/ganeti.rapi.baserlib_unittest.py \
1181         test/py/ganeti.rapi.client_unittest.py \
1182         test/py/ganeti.rapi.resources_unittest.py \
1183         test/py/ganeti.rapi.rlib2_unittest.py \
1184         test/py/ganeti.rapi.testutils_unittest.py \
1185         test/py/ganeti.rpc_unittest.py \
1186         test/py/ganeti.runtime_unittest.py \
1187         test/py/ganeti.serializer_unittest.py \
1188         test/py/ganeti.server.rapi_unittest.py \
1189         test/py/ganeti.ssconf_unittest.py \
1190         test/py/ganeti.ssh_unittest.py \
1191         test/py/ganeti.storage_unittest.py \
1192         test/py/ganeti.tools.burnin_unittest.py \
1193         test/py/ganeti.tools.ensure_dirs_unittest.py \
1194         test/py/ganeti.tools.node_daemon_setup_unittest.py \
1195         test/py/ganeti.tools.prepare_node_join_unittest.py \
1196         test/py/ganeti.uidpool_unittest.py \
1197         test/py/ganeti.utils.algo_unittest.py \
1198         test/py/ganeti.utils.filelock_unittest.py \
1199         test/py/ganeti.utils.hash_unittest.py \
1200         test/py/ganeti.utils.io_unittest-runasroot.py \
1201         test/py/ganeti.utils.io_unittest.py \
1202         test/py/ganeti.utils.log_unittest.py \
1203         test/py/ganeti.utils.lvm_unittest.py \
1204         test/py/ganeti.utils.mlock_unittest.py \
1205         test/py/ganeti.utils.nodesetup_unittest.py \
1206         test/py/ganeti.utils.process_unittest.py \
1207         test/py/ganeti.utils.retry_unittest.py \
1208         test/py/ganeti.utils.text_unittest.py \
1209         test/py/ganeti.utils.wrapper_unittest.py \
1210         test/py/ganeti.utils.x509_unittest.py \
1211         test/py/ganeti.utils_unittest.py \
1212         test/py/ganeti.vcluster_unittest.py \
1213         test/py/ganeti.workerpool_unittest.py \
1214         test/py/pycurl_reset_unittest.py \
1215         test/py/qa.qa_config_unittest.py \
1216         test/py/tempfile_fork_unittest.py
1217
1218 haskell_tests = test/hs/htest
1219
1220 dist_TESTS = \
1221         test/py/check-cert-expired_unittest.bash \
1222         test/py/daemon-util_unittest.bash \
1223         test/py/ganeti-cleaner_unittest.bash \
1224         test/py/import-export_unittest.bash \
1225         test/py/cli-test.bash \
1226         test/py/bash_completion.bash \
1227         $(python_tests)
1228
1229 nodist_TESTS =
1230 check_SCRIPTS =
1231
1232 if WANT_HSTESTS
1233 nodist_TESTS += $(haskell_tests)
1234 dist_TESTS += test/hs/offline-test.sh
1235 check_SCRIPTS += \
1236         test/hs/hpc-htools \
1237         test/hs/hpc-mon-collector \
1238         $(HS_BUILT_TEST_HELPERS)
1239 endif
1240
1241 TESTS = $(dist_TESTS) $(nodist_TESTS)
1242
1243 # Environment for all tests
1244 PLAIN_TESTS_ENVIRONMENT = \
1245         PYTHONPATH=. \
1246         TOP_SRCDIR=$(abs_top_srcdir) TOP_BUILDDIR=$(abs_top_builddir) \
1247         PYTHON=$(PYTHON) FAKEROOT=$(FAKEROOT_PATH) \
1248         $(RUN_IN_TEMPDIR)
1249
1250 # Environment for tests run by automake
1251 TESTS_ENVIRONMENT = \
1252         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/testrunner
1253
1254 all_python_code = \
1255         $(dist_sbin_SCRIPTS) \
1256         $(python_scripts) \
1257         $(pkglib_python_scripts) \
1258         $(nodist_pkglib_python_scripts) \
1259         $(nodist_tools_python_scripts) \
1260         $(python_tests) \
1261         $(pkgpython_PYTHON) \
1262         $(client_PYTHON) \
1263         $(hypervisor_PYTHON) \
1264         $(block_PYTHON) \
1265         $(rapi_PYTHON) \
1266         $(server_PYTHON) \
1267         $(pytools_PYTHON) \
1268         $(http_PYTHON) \
1269         $(confd_PYTHON) \
1270         $(masterd_PYTHON) \
1271         $(impexpd_PYTHON) \
1272         $(utils_PYTHON) \
1273         $(watcher_PYTHON) \
1274         $(noinst_PYTHON) \
1275         $(qa_scripts)
1276
1277 srclink_files = \
1278         man/footer.rst \
1279         test/py/check-cert-expired_unittest.bash \
1280         test/py/daemon-util_unittest.bash \
1281         test/py/ganeti-cleaner_unittest.bash \
1282         test/py/import-export_unittest.bash \
1283         test/py/cli-test.bash \
1284         test/py/bash_completion.bash \
1285         test/hs/offline-test.sh \
1286         test/hs/cli-tests-defs.sh \
1287         $(all_python_code) \
1288         $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS) \
1289         $(docinput)
1290
1291 check_python_code = \
1292         $(BUILD_BASH_COMPLETION) \
1293         $(CHECK_IMPORTS) \
1294         $(CHECK_HEADER) \
1295         $(DOCPP) \
1296         $(all_python_code)
1297
1298 lint_python_code = \
1299         ganeti \
1300         ganeti/http/server.py \
1301         $(dist_sbin_SCRIPTS) \
1302         $(python_scripts) \
1303         $(pkglib_python_scripts) \
1304         $(BUILD_BASH_COMPLETION) \
1305         $(CHECK_IMPORTS) \
1306         $(CHECK_HEADER) \
1307         $(DOCPP) \
1308         $(PYTHON_BOOTSTRAP)
1309
1310 standalone_python_modules = \
1311         lib/rapi/client.py \
1312         tools/ganeti-listrunner
1313
1314 pep8_python_code = \
1315         ganeti \
1316         ganeti/http/server.py \
1317         $(dist_sbin_SCRIPTS) \
1318         $(python_scripts) \
1319         $(pkglib_python_scripts) \
1320         $(BUILD_BASH_COMPLETION) \
1321         $(CHECK_HEADER) \
1322         $(DOCPP) \
1323         $(PYTHON_BOOTSTRAP) \
1324         qa
1325
1326 test/py/daemon-util_unittest.bash: daemons/daemon-util
1327
1328 test/py/ganeti-cleaner_unittest.bash: daemons/ganeti-cleaner
1329
1330 test/py/bash_completion.bash: doc/examples/bash_completion-debug
1331
1332 tools/kvm-ifup: tools/kvm-ifup.in $(REPLACE_VARS_SED)
1333         sed -f $(REPLACE_VARS_SED) < $< > $@
1334         chmod +x $@
1335
1336 tools/users-setup: tools/users-setup.in $(REPLACE_VARS_SED)
1337         sed -f $(REPLACE_VARS_SED) < $< > $@
1338         chmod +x $@
1339
1340 tools/vcluster-setup: tools/vcluster-setup.in $(REPLACE_VARS_SED)
1341         sed -f $(REPLACE_VARS_SED) < $< > $@
1342         chmod +x $@
1343
1344 daemons/%:: daemons/%.in $(REPLACE_VARS_SED)
1345         sed -f $(REPLACE_VARS_SED) < $< > $@
1346         chmod +x $@
1347
1348 doc/examples/%:: doc/examples/%.in $(REPLACE_VARS_SED)
1349         sed -f $(REPLACE_VARS_SED) < $< > $@
1350
1351 doc/examples/bash_completion: BC_ARGS = --compact
1352 doc/examples/bash_completion-debug: BC_ARGS =
1353
1354 doc/examples/bash_completion doc/examples/bash_completion-debug: \
1355         $(BUILD_BASH_COMPLETION) $(RUN_IN_TEMPDIR) \
1356         lib/cli.py $(gnt_scripts) $(client_PYTHON) tools/burnin \
1357         daemons/ganeti-cleaner \
1358         $(GENERATED_FILES) $(HS_GENERATED_FILES)
1359         PYTHONPATH=. $(RUN_IN_TEMPDIR) \
1360           $(CURDIR)/$(BUILD_BASH_COMPLETION) $(BC_ARGS) > $@
1361
1362 man/%.gen: man/%.rst lib/query.py lib/build/sphinx_ext.py \
1363         lib/build/shell_example_lexer.py \
1364         | $(RUN_IN_TEMPDIR) $(BUILT_PYTHON_SOURCES)
1365         @echo "Checking $< for hardcoded paths..."
1366         @if grep -nEf autotools/wrong-hardcoded-paths $<; then \
1367           echo "Man page $< has hardcoded paths (see above)!" 1>&2 ; \
1368           exit 1; \
1369         fi
1370         set -e ; \
1371         trap 'echo auto-removing $@; rm $@' EXIT; \
1372         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(DOCPP) < $< > $@ ;\
1373         $(CHECK_MAN_REFERENCES) $@; \
1374         trap - EXIT
1375
1376 man/%.7.in man/%.8.in man/%.1.in: man/%.gen man/footer.rst
1377         @test -n "$(PANDOC)" || \
1378           { echo 'pandoc' not found during configure; exit 1; }
1379         set -o pipefail -e; \
1380         trap 'echo auto-removing $@; rm $@' EXIT; \
1381         $(PANDOC) -s -f rst -t man $< man/footer.rst | \
1382           sed -e 's/\\@/@/g' > $@; \
1383         if test -n "$(MAN_HAS_WARNINGS)"; then $(CHECK_MAN_WARNINGS) $@; fi; \
1384         $(CHECK_MAN_DASHES) $@; \
1385         trap - EXIT
1386
1387 man/%.html.in: man/%.gen man/footer.rst
1388         @test -n "$(PANDOC)" || \
1389           { echo 'pandoc' not found during configure; exit 1; }
1390         set -o pipefail ; \
1391         $(PANDOC) --toc -s -f rst -t html $< man/footer.rst | \
1392           sed -e 's/\\@/@/g' > $@
1393
1394 man/%: man/%.in  $(REPLACE_VARS_SED)
1395         sed -f $(REPLACE_VARS_SED) < $< > $@
1396
1397 epydoc.conf: epydoc.conf.in $(REPLACE_VARS_SED)
1398         sed -f $(REPLACE_VARS_SED) < $< > $@
1399
1400 vcs-version:
1401         if test -d .git; then \
1402           git describe > $@; \
1403         elif test ! -f $@ ; then \
1404           echo "Cannot auto-generate $@ file"; exit 1; \
1405         fi
1406
1407 .PHONY: clean-vcs-version
1408 clean-vcs-version:
1409         rm -f vcs-version
1410
1411 .PHONY: regen-vcs-version
1412 regen-vcs-version:
1413         @set -e; \
1414         cd $(srcdir); \
1415         if test -d .git; then \
1416           T=`mktemp` ; trap 'rm -f $$T' EXIT; \
1417           git describe > $$T; \
1418           if ! cmp --quiet $$T vcs-version; then \
1419             mv $$T vcs-version; \
1420           fi; \
1421         fi
1422
1423 src/Ganeti/Version.hs: src/Ganeti/Version.hs.in \
1424         vcs-version $(built_base_sources)
1425         set -e; \
1426         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1427         sed -e "s/%ver%/$$VCSVER/" < $< > $@
1428
1429 src/Ganeti/Constants.hs: src/Ganeti/Constants.hs.in \
1430         lib/constants.py lib/_autoconf.py lib/luxi.py lib/errors.py \
1431         lib/jstore.py $(RUN_IN_TEMPDIR) \
1432         $(CONVERT_CONSTANTS) $(built_base_sources) \
1433         | lib/_vcsversion.py
1434         set -e; \
1435         { cat $< ; \
1436           PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CONVERT_CONSTANTS); \
1437         } > $@
1438
1439 src/Ganeti/Curl/Internal.hs: src/Ganeti/Curl/Internal.hsc | stamp-directories
1440         hsc2hs -o $@ $<
1441
1442 test/hs/Test/Ganeti/TestImports.hs: test/hs/Test/Ganeti/TestImports.hs.in \
1443         $(built_base_sources)
1444         set -e; \
1445         { cat $< ; \
1446           echo ; \
1447           for name in $(filter-out Ganeti.THH,$(subst /,.,$(patsubst %.hs,%,$(patsubst src/%,%,$(HS_LIB_SRCS))))) ; do \
1448             echo "import $$name ()" ; \
1449           done ; \
1450         } > $@
1451
1452 lib/_autoconf.py: Makefile | stamp-directories
1453         set -e; \
1454         { echo '# This file is automatically generated, do not edit!'; \
1455           echo '#'; \
1456           echo ''; \
1457           echo '"""Build-time configuration for Ganeti.'; \
1458           echo '';\
1459           echo 'This file is autogenerated by the build process.'; \
1460           echo 'For any changes you need to re-run ./configure (and'; \
1461           echo 'not edit by hand).'; \
1462           echo ''; \
1463           echo '"""'; \
1464           echo ''; \
1465           echo '# pylint: disable=C0301,C0324'; \
1466           echo '# because this is autogenerated, we do not want'; \
1467           echo '# style warnings' ; \
1468           echo ''; \
1469           echo "PACKAGE_VERSION = '$(PACKAGE_VERSION)'"; \
1470           echo "VERSION_MAJOR = '$(VERSION_MAJOR)'"; \
1471           echo "VERSION_MINOR = '$(VERSION_MINOR)'"; \
1472           echo "VERSION_REVISION = '$(VERSION_REVISION)'"; \
1473           echo "VERSION_SUFFIX = '$(VERSION_SUFFIX)'"; \
1474           echo "VERSION_FULL = '$(VERSION_FULL)'"; \
1475           echo "LOCALSTATEDIR = '$(localstatedir)'"; \
1476           echo "SYSCONFDIR = '$(sysconfdir)'"; \
1477           echo "SSH_CONFIG_DIR = '$(SSH_CONFIG_DIR)'"; \
1478           echo "SSH_LOGIN_USER = '$(SSH_LOGIN_USER)'"; \
1479           echo "SSH_CONSOLE_USER = '$(SSH_CONSOLE_USER)'"; \
1480           echo "EXPORT_DIR = '$(EXPORT_DIR)'"; \
1481           echo "OS_SEARCH_PATH = [$(OS_SEARCH_PATH)]"; \
1482           echo "ES_SEARCH_PATH = [$(ES_SEARCH_PATH)]"; \
1483           echo "XEN_BOOTLOADER = '$(XEN_BOOTLOADER)'"; \
1484           echo "XEN_CONFIG_DIR = '$(XEN_CONFIG_DIR)'"; \
1485           echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
1486           echo "XEN_INITRD = '$(XEN_INITRD)'"; \
1487           echo "KVM_KERNEL = '$(KVM_KERNEL)'"; \
1488           echo "FILE_STORAGE_DIR = '$(FILE_STORAGE_DIR)'"; \
1489           echo "ENABLE_FILE_STORAGE = $(ENABLE_FILE_STORAGE)"; \
1490           echo "SHARED_FILE_STORAGE_DIR = '$(SHARED_FILE_STORAGE_DIR)'"; \
1491           echo "ENABLE_SHARED_FILE_STORAGE = $(ENABLE_SHARED_FILE_STORAGE)"; \
1492           echo "IALLOCATOR_SEARCH_PATH = [$(IALLOCATOR_SEARCH_PATH)]"; \
1493           echo "KVM_PATH = '$(KVM_PATH)'"; \
1494           echo "IP_PATH = '$(IP_PATH)'"; \
1495           echo "SOCAT_PATH = '$(SOCAT)'"; \
1496           echo "SOCAT_USE_ESCAPE = $(SOCAT_USE_ESCAPE)"; \
1497           echo "SOCAT_USE_COMPRESS = $(SOCAT_USE_COMPRESS)"; \
1498           echo "LVM_STRIPECOUNT = $(LVM_STRIPECOUNT)"; \
1499           echo "TOOLSDIR = '$(toolsdir)'"; \
1500           echo "GNT_SCRIPTS = [$(foreach i,$(notdir $(gnt_scripts)),'$(i)',)]"; \
1501           echo "HTOOLS_PROGS = [$(foreach i,$(HS_HTOOLS_PROGS),'$(i)',)]"; \
1502           echo "PKGLIBDIR = '$(pkglibdir)'"; \
1503           echo "DRBD_BARRIERS = '$(DRBD_BARRIERS)'"; \
1504           echo "DRBD_NO_META_FLUSH = $(DRBD_NO_META_FLUSH)"; \
1505           echo "SYSLOG_USAGE = '$(SYSLOG_USAGE)'"; \
1506           echo "DAEMONS_GROUP = '$(DAEMONS_GROUP)'"; \
1507           echo "ADMIN_GROUP = '$(ADMIN_GROUP)'"; \
1508           echo "MASTERD_USER = '$(MASTERD_USER)'"; \
1509           echo "MASTERD_GROUP = '$(MASTERD_GROUP)'"; \
1510           echo "RAPI_USER = '$(RAPI_USER)'"; \
1511           echo "RAPI_GROUP = '$(RAPI_GROUP)'"; \
1512           echo "CONFD_USER = '$(CONFD_USER)'"; \
1513           echo "CONFD_GROUP = '$(CONFD_GROUP)'"; \
1514           echo "NODED_USER = '$(NODED_USER)'"; \
1515           echo "NODED_GROUP = '$(NODED_GROUP)'"; \
1516           echo "MOND_USER = '$(MOND_USER)'"; \
1517           echo "MOND_GROUP = '$(MOND_GROUP)'"; \
1518           echo "DISK_SEPARATOR = '$(DISK_SEPARATOR)'"; \
1519           echo "QEMUIMG_PATH = '$(QEMUIMG_PATH)'"; \
1520           echo "HTOOLS = True"; \
1521           echo "ENABLE_CONFD = $(ENABLE_CONFD)"; \
1522           echo "XEN_CMD = '$(XEN_CMD)'"; \
1523           echo "ENABLE_SPLIT_QUERY = $(ENABLE_SPLIT_QUERY)"; \
1524           echo "ENABLE_RESTRICTED_COMMANDS = $(ENABLE_RESTRICTED_COMMANDS)"; \
1525           echo "ENABLE_MOND = $(ENABLE_MOND)"; \
1526 ## Write dictionary with man page name as the key and the section number as the
1527 ## value
1528           echo "MAN_PAGES = {"; \
1529           for i in $(notdir $(man_MANS)); do \
1530             echo "$$i" | sed -re 's/^(.*)\.([0-9]+)$$/  "\1": \2,/g'; \
1531           done; \
1532           echo "}"; \
1533         } > $@
1534
1535 lib/_vcsversion.py: Makefile vcs-version | stamp-directories
1536         set -e; \
1537         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1538         { echo '# This file is automatically generated, do not edit!'; \
1539           echo '#'; \
1540           echo ''; \
1541           echo '"""Build-time VCS version number for Ganeti.'; \
1542           echo '';\
1543           echo 'This file is autogenerated by the build process.'; \
1544           echo 'For any changes you need to re-run ./configure (and'; \
1545           echo 'not edit by hand).'; \
1546           echo ''; \
1547           echo '"""'; \
1548           echo ''; \
1549           echo '# pylint: disable=C0301,C0324'; \
1550           echo '# because this is autogenerated, we do not want'; \
1551           echo '# style warnings' ; \
1552           echo ''; \
1553           echo "VCS_VERSION = '$$VCSVER'"; \
1554         } > $@
1555
1556 lib/_generated_rpc.py: lib/rpc_defs.py $(BUILD_RPC)
1557         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_RPC) lib/rpc_defs.py > $@
1558
1559 $(SHELL_ENV_INIT): Makefile stamp-directories
1560         set -e; \
1561         { echo '# Allow overriding for tests'; \
1562           echo 'readonly LOCALSTATEDIR=$${LOCALSTATEDIR:-$${GANETI_ROOTDIR:-}$(localstatedir)}'; \
1563           echo 'readonly SYSCONFDIR=$${SYSCONFDIR:-$${GANETI_ROOTDIR:-}$(sysconfdir)}'; \
1564           echo; \
1565           echo 'readonly PKGLIBDIR=$(pkglibdir)'; \
1566           echo 'readonly LOG_DIR="$$LOCALSTATEDIR/log/ganeti"'; \
1567           echo 'readonly RUN_DIR="$$LOCALSTATEDIR/run/ganeti"'; \
1568           echo 'readonly DATA_DIR="$$LOCALSTATEDIR/lib/ganeti"'; \
1569           echo 'readonly CONF_DIR="$$SYSCONFDIR/ganeti"'; \
1570         } > $@
1571
1572 ## Writes sed script to replace placeholders with build-time values. The
1573 ## additional quotes after the first @ sign are necessary to stop configure
1574 ## from replacing those values as well.
1575 $(REPLACE_VARS_SED): $(SHELL_ENV_INIT) Makefile stamp-directories
1576         set -e; \
1577         { echo 's#@''PREFIX@#$(prefix)#g'; \
1578           echo 's#@''SYSCONFDIR@#$(sysconfdir)#g'; \
1579           echo 's#@''LOCALSTATEDIR@#$(localstatedir)#g'; \
1580           echo 's#@''BINDIR@#$(bindir)#g'; \
1581           echo 's#@''SBINDIR@#$(sbindir)#g'; \
1582           echo 's#@''LIBDIR@#$(libdir)#g'; \
1583           echo 's#@''GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
1584           echo 's#@''CUSTOM_XEN_BOOTLOADER@#$(XEN_BOOTLOADER)#g'; \
1585           echo 's#@''CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
1586           echo 's#@''CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
1587           echo 's#@''CUSTOM_IALLOCATOR_SEARCH_PATH@#$(IALLOCATOR_SEARCH_PATH)#g'; \
1588           echo 's#@''CUSTOM_EXPORT_DIR@#$(EXPORT_DIR)#g'; \
1589           echo 's#@''RPL_FILE_STORAGE_DIR@#$(FILE_STORAGE_DIR)#g'; \
1590           echo 's#@''RPL_SSH_INITD_SCRIPT@#$(SSH_INITD_SCRIPT)#g'; \
1591           echo 's#@''PKGLIBDIR@#$(pkglibdir)#g'; \
1592           echo 's#@''GNTMASTERUSER@#$(MASTERD_USER)#g'; \
1593           echo 's#@''GNTRAPIUSER@#$(RAPI_USER)#g'; \
1594           echo 's#@''GNTCONFDUSER@#$(CONFD_USER)#g'; \
1595           echo 's#@''GNTNODEDUSER@#$(NODED_USER)#g'; \
1596           echo 's#@''GNTMONDUSER@#$(MOND_USER)#g'; \
1597           echo 's#@''GNTRAPIGROUP@#$(RAPI_GROUP)#g'; \
1598           echo 's#@''GNTADMINGROUP@#$(ADMIN_GROUP)#g'; \
1599           echo 's#@''GNTCONFDGROUP@#$(CONFD_GROUP)#g'; \
1600           echo 's#@''GNTMASTERDGROUP@#$(MASTERD_GROUP)#g'; \
1601           echo 's#@''GNTMONDGROUP@#$(MOND_GROUP)#g'; \
1602           echo 's#@''GNTDAEMONSGROUP@#$(DAEMONS_GROUP)#g'; \
1603           echo 's#@''CUSTOM_ENABLE_CONFD@#$(ENABLE_CONFD)#g'; \
1604           echo 's#@''CUSTOM_ENABLE_MOND@#$(ENABLE_MOND)#g'; \
1605           echo 's#@''MODULES@#$(strip $(lint_python_code))#g'; \
1606           echo 's#@''XEN_CONFIG_DIR@#$(XEN_CONFIG_DIR)#g'; \
1607           echo; \
1608           echo '/^@SHELL_ENV_INIT@$$/ {'; \
1609           echo '  r $(SHELL_ENV_INIT)'; \
1610           echo '  d'; \
1611           echo '}'; \
1612         } > $@
1613
1614 # Using deferred evaluation
1615 daemons/ganeti-%: MODULE = ganeti.server.$(patsubst ganeti-%,%,$(notdir $@))
1616 daemons/ganeti-watcher: MODULE = ganeti.watcher
1617 scripts/%: MODULE = ganeti.client.$(subst -,_,$(notdir $@))
1618 tools/burnin: MODULE = ganeti.tools.burnin
1619 tools/ensure-dirs: MODULE = ganeti.tools.ensure_dirs
1620 tools/node-daemon-setup: MODULE = ganeti.tools.node_daemon_setup
1621 tools/prepare-node-join: MODULE = ganeti.tools.prepare_node_join
1622 tools/node-cleanup: MODULE = ganeti.tools.node_cleanup
1623 $(HS_BUILT_TEST_HELPERS): TESTROLE = $(patsubst test/hs/%,%,$@)
1624
1625 $(PYTHON_BOOTSTRAP): Makefile | stamp-directories
1626         test -n "$(MODULE)" || { echo Missing module; exit 1; }
1627         set -e; \
1628         { echo '#!/usr/bin/python'; \
1629           echo '# This file is automatically generated, do not edit!'; \
1630           echo "# Edit $(MODULE) instead."; \
1631           echo; \
1632           echo '"""Bootstrap script for L{$(MODULE)}"""'; \
1633           echo; \
1634           echo '# pylint: disable=C0103'; \
1635           echo '# C0103: Invalid name'; \
1636           echo; \
1637           echo 'import sys'; \
1638           echo 'import $(MODULE) as main'; \
1639           echo; \
1640           echo '# Temporarily alias commands until bash completion'; \
1641           echo '# generator is changed'; \
1642           echo 'if hasattr(main, "commands"):'; \
1643           echo '  commands = main.commands # pylint: disable=E1101'; \
1644           echo 'if hasattr(main, "aliases"):'; \
1645           echo '  aliases = main.aliases # pylint: disable=E1101'; \
1646           echo; \
1647           echo 'if __name__ == "__main__":'; \
1648           echo '  sys.exit(main.Main())'; \
1649         } > $@
1650         chmod u+x $@
1651
1652 $(HS_BUILT_TEST_HELPERS): Makefile
1653         @test -n "$(TESTROLE)" || { echo Missing TESTROLE; exit 1; }
1654         set -e; \
1655         { echo '#!/bin/sh'; \
1656           echo '# This file is automatically generated, do not edit!'; \
1657           echo "# Edit Makefile.am instead."; \
1658           echo; \
1659           echo "HTOOLS=$(TESTROLE) exec ./test/hs/hpc-htools \"\$$@\""; \
1660         } > $@
1661         chmod u+x $@
1662
1663 stamp-directories: Makefile
1664         $(MAKE) $(AM_MAKEFLAGS) ganeti
1665         @mkdir_p@ $(DIRS) $(BUILDTIME_DIR_AUTOCREATE)
1666         touch $@
1667
1668 # We need to create symlinks because "make distcheck" will not install Python
1669 # files when building.
1670 stamp-srclinks: Makefile | stamp-directories
1671         set -e; \
1672         for i in $(srclink_files); do \
1673           if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
1674             $(LN_S) $(abs_top_srcdir)/$$i $$i; \
1675           fi; \
1676         done
1677         touch $@
1678
1679 .PHONY: ganeti
1680 ganeti:
1681         cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
1682
1683 .PHONY: check-dirs
1684 check-dirs: $(GENERATED_FILES)
1685         @set -e; \
1686         find . -type d \( -name . -o -name .git -prune -o -print \) | { \
1687           error=; \
1688           while read dir; do \
1689             case "$$dir" in \
1690               $(strip $(patsubst %,(./%) ;;,$(DIRCHECK_EXCLUDE) $(DIRS))) \
1691               *) error=1; echo "Directory $$dir not listed in Makefile" >&2 ;; \
1692             esac; \
1693           done; \
1694           for dir in $(DIRS); do \
1695             if ! test -d "$$dir"; then \
1696               echo "Directory $$dir listed in DIRS does not exist" >&2; \
1697               error=1; \
1698             fi \
1699           done; \
1700           test -z "$$error"; \
1701         }
1702
1703 .PHONY: check-local
1704 check-local: check-dirs $(GENERATED_FILES)
1705         $(CHECK_PYTHON_CODE) $(check_python_code)
1706         PYTHONPATH=. $(CHECK_HEADER) $(check_python_code)
1707         $(CHECK_VERSION) $(VERSION) $(top_srcdir)/NEWS
1708         RELEASE=$(PACKAGE_VERSION) $(CHECK_NEWS) < $(top_srcdir)/NEWS
1709         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CHECK_IMPORTS) . $(standalone_python_modules)
1710         @expver=$(VERSION_MAJOR).$(VERSION_MINOR); \
1711         error= ; \
1712         if test "`head -n 1 $(top_srcdir)/README`" != "Ganeti $$expver"; then \
1713           echo "Incorrect version in README, expected $$expver" >&2; \
1714           error=1; \
1715         fi; \
1716         for file in doc/iallocator.rst doc/hooks.rst doc/virtual-cluster.rst \
1717             doc/security.rst; do \
1718           if test "`sed -ne '4 p' $(top_srcdir)/$$file`" != \
1719             "Documents Ganeti version $$expver"; then \
1720             echo "Incorrect version in $$file, expected $$expver" >&2; \
1721             error=1; \
1722           fi; \
1723         done; \
1724         if ! test -f $(top_srcdir)/doc/design-$$expver.rst; then \
1725           echo "File $(top_srcdir)/doc/design-$$expver.rst not found" >&2; \
1726           error=1; \
1727         fi; \
1728         if test "`sed -ne '5 p' $(top_srcdir)/doc/design-draft.rst`" != \
1729           ".. Last updated for Ganeti $$expver"; then \
1730           echo "doc/design-draft.rst was not updated for version $$expver" >&2; \
1731           error=1; \
1732         fi; \
1733         for file in configure.ac $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS); do \
1734           if test $$(wc --max-line-length < $(top_srcdir)/$$file) -gt 80; then \
1735             echo "Longest line in $$file is longer than 80 characters" >&2; \
1736             error=1; \
1737           fi; \
1738         done; \
1739         test -z "$$error"
1740
1741 .PHONY: hs-tests
1742 hs-tests: test/hs/htest | $(BUILT_PYTHON_SOURCES)
1743         @rm -f htest.tix
1744         ./test/hs/htest
1745
1746 .PHONY: hs-shell
1747 hs-shell: test/hs/hpc-htools test/hs/hpc-mon-collector $(HS_BUILT_TEST_HELPERS)
1748         @rm -f hpc-htools.tix hpc-mon-collector.tix
1749         HBINARY="./test/hs/hpc-htools" ./test/hs/offline-test.sh
1750
1751 .PHONY: hs-check
1752 hs-check: hs-tests hs-shell
1753
1754 # E111: indentation is not a multiple of four
1755 # E121: continuation line indentation is not a multiple of four
1756 #       (since our indent level is not 4)
1757 # E125: continuation line does not distinguish itself from next logical line
1758 #       (since our indent level is not 4)
1759 # E127: continuation line over-indented for visual indent
1760 #       (since our indent level is not 4)
1761 # note: do NOT add E128 here; it's a valid style error in most cases!
1762 # I've seen real errors, but also some cases were we indent wrongly
1763 # due to line length; try to rework the cases where it is triggered,
1764 # instead of silencing it
1765 # E261: at least two spaces before inline comment
1766 # E501: line too long (80 characters)
1767 PEP8_IGNORE = E111,E121,E125,E127,E261,E501
1768
1769 # For excluding pep8 expects filenames only, not whole paths
1770 PEP8_EXCLUDE = $(subst $(space),$(comma),$(strip $(notdir $(BUILT_PYTHON_SOURCES))))
1771
1772 LINT_TARGETS = pylint pylint-qa
1773 if HAS_PEP8
1774 LINT_TARGETS += pep8
1775 endif
1776 if HAS_HLINT
1777 LINT_TARGETS += hlint
1778 endif
1779
1780 .PHONY: lint
1781 lint: $(LINT_TARGETS)
1782
1783 .PHONY: pylint
1784 pylint: $(GENERATED_FILES)
1785         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1786         $(PYLINT) $(LINT_OPTS) $(lint_python_code)
1787
1788 .PHONY: pylint-qa
1789 pylint-qa: $(GENERATED_FILES)
1790         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1791         cd $(top_srcdir)/qa && \
1792           PYTHONPATH=$(abs_top_srcdir) $(PYLINT) $(LINT_OPTS) \
1793           --rcfile  ../pylintrc $(patsubst qa/%.py,%,$(qa_scripts))
1794
1795 .PHONY: pep8
1796 pep8: $(GENERATED_FILES)
1797         @test -n "$(PEP8)" || { echo 'pep8' not found during configure; exit 1; }
1798         $(PEP8) --ignore='$(PEP8_IGNORE)' --exclude='$(PEP8_EXCLUDE)' \
1799           --repeat $(pep8_python_code)
1800
1801 # FIXME: remove ignore "Use void" when GHC 6.x is deprecated
1802 HLINT_EXCLUDES = src/Ganeti/THH.hs test/hs/hpc-htools.hs
1803 .PHONY: hlint
1804 hlint: $(HS_BUILT_SRCS) src/lint-hints.hs
1805         @test -n "$(HLINT)" || { echo 'hlint' not found during configure; exit 1; }
1806         @rm -f doc/hs-lint.html
1807         if tty -s; then C="-c"; else C=""; fi; \
1808         $(HLINT) --utf8 --report=doc/hs-lint.html --cross $$C \
1809           --ignore "Use first" \
1810           --ignore "Use &&&" \
1811           --ignore "Use void" \
1812           --ignore "Reduce duplication" \
1813           --hint src/lint-hints \
1814           $(filter-out $(HLINT_EXCLUDES),$(HS_LIBTEST_SRCS) $(HS_PROG_SRCS))
1815         @if [ ! -f doc/hs-lint.html ]; then \
1816           echo "All good" > doc/hs-lint.html; \
1817         fi
1818
1819 # a dist hook rule for updating the vcs-version file; this is
1820 # hardcoded due to where it needs to build the file...
1821 dist-hook:
1822         $(MAKE) $(AM_MAKEFLAGS) regen-vcs-version
1823         rm -f $(top_distdir)/vcs-version
1824         cp -p $(srcdir)/vcs-version $(top_distdir)
1825
1826 # a distcheck hook rule for catching revision control directories
1827 distcheck-hook:
1828         if find $(top_distdir) -name .svn -or -name .git | grep .; then \
1829           echo "Found revision control files in final archive." 1>&2; \
1830           exit 1; \
1831         fi
1832         if find $(top_distdir) -name '*.py[co]' | grep .; then \
1833           echo "Found Python byte code in final archive." 1>&2; \
1834           exit 1; \
1835         fi
1836         if find $(top_distdir) -name '*~' | grep .; then \
1837           echo "Found backup files in final archive." 1>&2; \
1838           exit 1; \
1839         fi
1840 # Empty files or directories should not be distributed. They can cause
1841 # unnecessary warnings for packagers. Directories used by automake during
1842 # distcheck must be excluded.
1843         if find $(top_distdir) -empty -and -not \( \
1844             -path $(top_distdir)/_build -or \
1845             -path $(top_distdir)/_inst \) | grep .; then \
1846           echo "Found empty files or directories in final archive." 1>&2; \
1847           exit 1; \
1848         fi
1849         if test -e $(top_distdir)/doc/man-html; then \
1850           echo "Found documentation including man pages in final archive" >&2; \
1851           exit 1; \
1852         fi
1853
1854 # Backwards compatible distcheck-release target
1855 distcheck-release: distcheck
1856
1857 distrebuildcheck: dist
1858         set -e; \
1859         builddir=$$(mktemp -d $(abs_srcdir)/distrebuildcheck.XXXXXXX); \
1860         trap "echo Removing $$builddir; cd $(abs_srcdir); rm -rf $$builddir" EXIT; \
1861         cd $$builddir; \
1862         tar xzf $(abs_srcdir)/$(distdir).tar.gz; \
1863         cd $(distdir); \
1864         ./configure; \
1865         $(MAKE) maintainer-clean; \
1866         cp $(abs_srcdir)/vcs-version .; \
1867         ./configure; \
1868         $(MAKE) $(AM_MAKEFLAGS)
1869
1870 dist-release: dist
1871         set -e; \
1872         for i in $(DIST_ARCHIVES); do \
1873           echo -n "Checking $$i ... "; \
1874           autotools/check-tar < $$i; \
1875           echo OK; \
1876         done
1877
1878 install-exec-local:
1879         @mkdir_p@ "$(DESTDIR)${localstatedir}/lib/ganeti" \
1880           "$(DESTDIR)${localstatedir}/log/ganeti" \
1881           "$(DESTDIR)${localstatedir}/run/ganeti"
1882
1883 .PHONY: apidoc
1884 if WANT_HSAPIDOC
1885 apidoc: py-apidoc hs-apidoc
1886 else
1887 apidoc: py-apidoc
1888 endif
1889
1890 .PHONY: py-apidoc
1891 py-apidoc: epydoc.conf $(RUN_IN_TEMPDIR) $(GENERATED_FILES)
1892         env - PATH="$$PATH" PYTHONPATH="$$PYTHONPATH" \
1893         $(RUN_IN_TEMPDIR) epydoc -v \
1894           --conf $(CURDIR)/epydoc.conf \
1895           --output $(CURDIR)/$(APIDOC_PY_DIR)
1896
1897 .PHONY: hs-apidoc
1898 hs-apidoc: $(APIDOC_HS_DIR)/index.html
1899
1900 $(APIDOC_HS_DIR)/index.html: $(HS_LIBTESTBUILT_SRCS) Makefile
1901         @test -n "$(HSCOLOUR)" || \
1902             { echo 'HsColour' not found during configure; exit 1; }
1903         @test -n "$(HADDOCK)" || \
1904             { echo 'haddock' not found during configure; exit 1; }
1905         rm -rf $(APIDOC_HS_DIR)/*
1906         for i in $(ALL_APIDOC_HS_DIRS); do \
1907           @mkdir_p@ $$i; \
1908           $(HSCOLOUR) -print-css > $$i/hscolour.css; \
1909         done
1910         set -e ; \
1911         export LC_ALL=en_US.UTF-8; \
1912         OPTGHC="--optghc=-isrc --optghc=-itest/hs"; \
1913         if [ "$(HS_PARALLEL3)" ]; \
1914         then OPTGHC="$$OPTGHC --optghc=$(HS_PARALLEL3)"; \
1915         fi; \
1916         if [ "$(HS_REGEX_PCRE)" ]; \
1917         then OPTGHC="$$OPTGHC --optghc=$(HS_REGEX_PCRE)"; \
1918         fi; \
1919         for file in $(HS_LIBTESTBUILT_SRCS); do \
1920           f_nosrc=$${file##src/}; \
1921           f_notst=$${f_nosrc##test/hs/}; \
1922           f_html=$${f_notst%%.hs}.html; \
1923           $(HSCOLOUR) -css -anchor $$file > $(APIDOC_HS_DIR)/$$f_html ; \
1924         done ; \
1925         $(HADDOCK) --odir $(APIDOC_HS_DIR) --html --ignore-all-exports -w \
1926           -t ganeti -p src/haddock-prologue \
1927           --source-module="%{MODULE/.//}.html" \
1928           --source-entity="%{MODULE/.//}.html#%{NAME}" \
1929           $$OPTGHC \
1930           $(HS_LIBTESTBUILT_SRCS)
1931
1932 .PHONY: TAGS
1933 TAGS: $(GENERATED_FILES)
1934         rm -f TAGS
1935         $(GHC) -e ":etags" -v0 \
1936           $(filter-out -O -Werror,$(HFLAGS)) \
1937           $(HS_PARALLEL3) $(HS_REGEX_PCRE) \
1938           $(HS_LIBTEST_SRCS)
1939         find . -path './lib/*.py' -o -path './scripts/gnt-*' -o \
1940           -path './daemons/ganeti-*' -o -path './tools/*' -o \
1941           -path './qa/*.py' | \
1942           etags -l python -a -
1943
1944 .PHONY: coverage
1945 if WANT_HTOOLS
1946 coverage: py-coverage hs-coverage
1947 else
1948 coverage: py-coverage
1949 endif
1950
1951 .PHONY: py-coverage
1952 py-coverage: $(GENERATED_FILES) $(python_tests)
1953         @test -n "$(PYCOVERAGE)" || \
1954             { echo 'python-coverage' not found during configure; exit 1; }
1955         set -e; \
1956         COVERAGE=$(PYCOVERAGE) \
1957         COVERAGE_FILE=$(CURDIR)/$(COVERAGE_PY_DIR)/data \
1958         TEXT_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR)/report.txt \
1959         HTML_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR) \
1960         $(PLAIN_TESTS_ENVIRONMENT) \
1961         $(abs_top_srcdir)/autotools/gen-py-coverage \
1962         $(python_tests)
1963
1964 .PHONY: hs-coverage
1965 hs-coverage: $(haskell_tests) test/hs/hpc-htools test/hs/hpc-mon-collector
1966         rm -f *.tix
1967         $(MAKE) $(AM_MAKEFLAGS) hs-check
1968         @mkdir_p@ $(COVERAGE_HS_DIR)
1969         hpc sum --union $(HPCEXCL) \
1970           htest.tix hpc-htools.tix hpc-mon-collector.tix > coverage-hs.tix
1971         hpc markup --destdir=$(COVERAGE_HS_DIR) coverage-hs.tix
1972         hpc report coverage-hs.tix
1973         $(LN_S) -f hpc_index.html $(COVERAGE_HS_DIR)/index.html
1974
1975 # Special "kind-of-QA" target for htools, needs special setup (all
1976 # tools compiled with -fhpc)
1977 .PHONY: live-test
1978 live-test: all
1979         set -e ; \
1980         cd src; \
1981         rm -f .hpc; $(LN_S) ../.hpc .hpc; \
1982         rm -f *.tix *.mix; \
1983         ./live-test.sh; \
1984         hpc sum --union $(HPCEXCL) $(addsuffix .tix,$(HS_PROGS:src/%=%)) \
1985           --output=live-test.tix ; \
1986         @mkdir_p@ ../$(COVERAGE_HS_DIR) ; \
1987         hpc markup --destdir=../$(COVERAGE_HS_DIR) live-test \
1988           --srcdir=.. $(HPCEXCL) ; \
1989         hpc report --srcdir=.. live-test $(HPCEXCL)
1990
1991 commit-check: distcheck lint apidoc
1992
1993 .PHONY: gitignore-check
1994 gitignore-check:
1995         @if [ -n "`git status --short`" ]; then \
1996           echo "Git status is not clean!" 1>&2 ; \
1997           git status --short; \
1998           exit 1; \
1999         fi
2000
2001 # target to rebuild all man pages (both groff and html output)
2002 .PHONY: man
2003 man: $(man_MANS) $(manhtml)
2004
2005 # Target that builds all binaries (including those that are not
2006 # rebuilt except when running the tests)
2007 .PHONY: really-all
2008 really-all: all $(check_SCRIPTS) $(haskell_tests) $(HS_ALL_PROGS)
2009
2010 # we don't need the ancient implicit rules:
2011 %: %,v
2012 %: RCS/%,v
2013 %: RCS/%
2014 %: s.%
2015 %: SCCS/s.%
2016
2017 -include ./Makefile.local
2018
2019 # vim: set noet :